/***********************************************************************/
/*  Easyflow is (C) 1999-2001 lamagra.seKure.de  This program is free  */
/*  software; you can redistribute it and/or modify it under the terms */
/*  of the GNU General Public License as published by the Free Software*/
/*  Foundation; Version 2.  This guarantees your right to use, modify, */
/*  and redistribute this software under certain conditions.           */
/*                                                                     */
/*  If you received these files with a written license agreement       */
/*  stating terms other than the (GPL) terms above, then that          */
/*  alternative license agreement takes precendence over this comment. */
/*                                                                     */
/*  Source is provided to this software because we believe users have  */
/*  a right to know exactly what a program is going to do before they  */
/*  run it.  This also allows you to audit the software for security   */
/*  holes (none have been found so far).                               */
/*                                                                     */
/*  This program is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of     */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU  */
/*  General Public License for more details (                          */
/*  http://www.gnu.org/copyleft/gpl.html ).                            */
/*                                                                     */
/***********************************************************************/
void calc_help()
{
    cout << "Calculator help:\n\n"
         << "\t*, +, -, /   : standard stuff\n"
         << "\t^            : xor\n"
         << "\t%            : modulus\n"
         << "\t<            : minimum (useful in shellscripts)\n"
         << "\t>            : maximum\n"
         << "\tshellcode    : the size of the shellcode\n"
         << "(It is possible to put expressions into a multiplier)\n"
         << "\nExample:\n\t ($a > $b) + 200 - linux.bind\n"
         << endl;
    exit(-1);
}

void format_help()
{
    cout << "Format string sequences:\n\n"
         << "\t<name>     : inserts shellcode with name \"name\"\n" 
         << "\t[X,string] : repeats string X times (\"string\" is parsed as well)\n"
         << "\t             X is a calculator expression (check -wc)\n"
         << "\t{[L,l] X } : L or l (optional) little endian and big endian notation\n"
         << "\t             X is a calculator expression\n" 
         << "\t\\xXX       : a hex byte in (XX)\n"
         << "\t\\lxxxxxxxx : put an hex addy in (little endian)\n"
         << "\t\\Lxxxxxxxx : put an hex addy in (big endian)\n"
         << "\t\\s         : sleep 1 second (gets a little messy when put inside [])\n"
         << "\t\\n \\t \\a \\r\n"
         << "\t\\\\          : check the printf man page" << endl;
      
    cout << "\nExample:\n"
         << "\t\"[360,\\x90]<linux.readexec>\\n\"" << endl;
    exit(-1);
}

void usage(char *name)
{
        cout << "Easyflow by lamagra <lamagra@digibel.org>" << endl;
        cout << "Get new releases from http://lamagra.seKure.de" << endl;
        cout << "Usage: " << name << "[options] <format string> [......]" << endl;
        cout << "Options:\n"
             << "\t-wX  : help on X:\n"
             << "\t         s: the formats you can use\n"
             << "\t         c: calculator usage\n"
             << "\t-a <cmd> : command to run after the strings have been printed\n"
             << "\t-g <name>: generate C-code from every buffer (name0..nameN)\n"
             << "\t-d <cmd> : use every string as an argument to \'cmd\'\n"
             << "\t-n       : put a newline behind every string\n"
             << "\t-e <var> : store every string in environment \'var\' (var0..varN)\n"
             << "\t-f       : make an %n string, syntax: <addy>[,<numbytes>[,num %n's]]\n"
             << "\t           addy being the addy to encode\n"
             << "\t           numbytes being the starting number of bytes\n" 
             << "\t           num %n's is the number of %n's to encode it in\n" 
             << "\t-t       : telnet escape (\\xff -> \\xff\\xff)\n"
             << "\t-l       : print a list of all shellcodes, name and explanation\n"
             << "\t-c       : Built-in calculator\n";
        exit(-1);
}
